!***************************************************************
!*
!*		Module for master operations
!* 
!***************************************************************
  MODULE master_variables
     IMPLICIT NONE
     SAVE
!
!***  Parameters
!
      real(kind=4),parameter :: pi = 3.14159265358979
      real(kind=4),parameter :: gi = 9.81
!
!***  Time related variables read from the input file
! 
      integer(kind=4) :: ibyr,ibmo,ibdy,ibhr,ibmi
      real   (kind=4) :: trun                                                
!
!***  Other time related variables
!
      character(len=3), dimension(12) :: month = (/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC' /)
!
!***  Grid variables
!
      integer(kind=4) :: nx,ny
	  real   (kind=4) :: dx,dy,x0,y0
!
!***  Meteo parameters
!
      real     (kind=4 ) :: zref,zrough_stat,x_stat,y_stat
      real     (kind=4 ) :: Tz0,Tzref,pres
!
!***  Vectors
!
      real(kind=4), allocatable :: g     (:,:)     ! g     (nx,ny)  topography
      real(kind=4), allocatable :: zrough(:,:)     ! zrough(nx,ny)  roughness
      real(kind=4), allocatable :: u     (:,:)     ! u     (nx,ny)  
      real(kind=4), allocatable :: v     (:,:)     ! v     (nx,ny)  

!
 CONTAINS
!
	  subroutine getmem
!**********************************************************************
!*
!*    Allocates memory for arrays related to nx,ny
!*
!**********************************************************************
	  implicit none
!
      allocate(g(nx,ny))
	  g = 0.
!
      allocate(zrough(nx,ny))
	  zrough = 0.
!
      allocate(u(nx,ny))
	  u = 0.
!
      allocate(v(nx,ny))
	  v = 0.
!
      end subroutine getmem
!	  
 END MODULE master_variables

      
