      SUBROUTINE BARIER(X,Y,XS,YS,OK)
C
C     DIAGNO  VERSION 1.1  LEVEL 900221  BARIER
C
      PARAMETER (MAXBAR = 20)
      DIMENSION A(3), B(3), C(3)
      COMMON /D3/ IFIN,NUMBAS,BAS(4,MAXBAR),SLPIN(2,MAXBAR)
C
C     THIS ROUTINE CALCULATES WHAT SIDE OF A BARRIER A POINT IS ON
C     BARRIERS ARE FINITE LENGTH LINE SEGMENTS
C
C     INPUTS:  BAS(1,I) (R) - UTM-X COORDINATE OF FIRST END POINT
C              BAS(2,I) (R) - UTM-Y COORDINATE OF FIRST END POINT
C              BAS(3,I) (R) - UTM-X COORDINATE OF SECOND END POINT
C              BAS(4,I) (R) - UTM-Y COORDINATE OF SECOND END POINT
C              NUMBAS (I)   - NUMBER OF BARRIERS (UP TO 20)
C              IFIN  (I)    - IF 0 SET UP PT SLOPE LINES
C              X (R)        - X-COORDINATE OF POINT OF INTEREST
C              Y (R)        - Y-COORDINATE OF POINT OF INTEREST
C              XS (R)       - X-COORDINATE OF REFERENCE POINT
C              YS (R)       - Y-COORDINATE OF REFERENCE POINT
C
C     OUTPUTS:  SLPIN(1,I) (R) - SLOPE OF LINE
C               SLPIN(2,I) (R) - INTERCEPT OF LINE
C               OK (R)         - FLAG IF POS (X-Y) IS ON SAME SIDE A
C                                (XS-YS)
      OK = 1.0
      IF (NUMBAS .LE. 0) GO TO 140
      IF (IFIN .GT. 0) GO TO 110
C
C
C     SETUP SLOPE INTERCEPT FORM OF A LINE
C
C
      DO 100 I = 1,NUMBAS
      DY = BAS(2,I)-BAS(4,I)
      DX = BAS(1,I)-BAS(3,I)
      SLPIN(1,I) = DY/DX
      SLPIN(2,I) = BAS(2,I)-SLPIN(1,I)*BAS(1,I)
  100 CONTINUE
      IFIN = 1
C
  110 CONTINUE
      C(1) = XS-X
      C(2) = YS-Y
      A(3) = 0.
      B(3) = 0.
      C(3) = 0.
      DO 120 I = 1,NUMBAS
      D1 = YS-SLPIN(1,I)*XS-SLPIN(2,I)
      D2 = Y-SLPIN(1,I)*X-SLPIN(2,I)
      IF (D1*D2.GE.0.) GO TO 120
      A(1) = BAS(1,I)-X
      A(2) = BAS(2,I)-Y
      B(1) = BAS(3,I)-X
      B(2) = BAS(4,I)-Y
      COSAB = UNIDOT(A,B)
      COSAC = UNIDOT(A,C)
      COSBC = UNIDOT(B,C)
      IF (COSAC .LT. COSAB .OR. COSBC .LT. COSAB) GO TO 120
      OK = -1.0
      GO TO 130
  120 CONTINUE
  130 CONTINUE
C
  140 CONTINUE
      RETURN
      END