      subroutine decode(card,words,param,nword,npar)
c********************************************************************
c*
c*    This routine decodes a string card(256) into words and parameters 
c*
c********************************************************************
      implicit none
	integer*4     nword,npar
	character*256 card
	character*256 words(128)
      real*8        param(128)
c
      integer*4 ipos,first,last,nstr,lflag,i,iword
	real*8    digit
c
c***  Initializations
c
      nword = 0
	npar  = 0     
      ipos  = 0
c
	do while(1.ne.0)
c                                    ! First position
         ipos = ipos + 1
         if(ipos.gt.256) return 
  10	   if(card(ipos:ipos).eq.' '.or.card(ipos:ipos).eq.'=') then
	     ipos = ipos + 1 
           if(ipos.gt.256) return 
           go to 10
         end if
         first = ipos
c
         ipos = ipos + 1
         if(ipos.gt.256) return 
  20	   if(card(ipos:ipos).ne.' '.and.card(ipos:ipos).ne.'=') then
	     ipos = ipos + 1 
           if(ipos.gt.256) return 
           go to 20
         end if
         last = ipos-1
c
         nstr = last-first+1
         call decod1(card(first:last),nstr,lflag,digit)
	   if(lflag.eq.0) then
            npar = npar + 1
		  param(npar)= digit
	   else if(lflag.eq.1) then
	      nword = nword + 1
            do i=1,256
               words(nword)(i:i) = ' '
	      end do
		  words(nword)(1:nstr) = card(first:last)
         end if
c
      end do
	end 
c
      subroutine decod1(string,nstr,lflag,digit)
c*******************************************************************
c*
c*    This subroutine decodes a single string(1:nstr) 
c*    
c*    If string(1:nstr) is a string returns lflag = 1
c*    If string(1:nstr) is a number returns lflag = 0 and the digit
c*
c*******************************************************************
      implicit none
      integer*4   nstr,lflag
	integer*4   istr,decim
      real*8      digit
      character*1 string(nstr)
	real*8      stof                                      ! Function
c	  
      lflag = 0                                             ! Number by default
      istr  = 1
c      
	do while(istr.le.nstr)
        decim = ichar(string(istr))                         ! decimal value
        if(decim.lt.48.or.decim.gt.57) then                 ! It is not a num.
           if(decim.ne.43 .and.decim.ne.45 .and.            ! discard + -
     .        decim.ne.68 .and.decim.ne.69 .and.            ! discard D E
     .        decim.ne.100.and.decim.ne.101.and.            ! discard d e
     .        decim.ne.46) then                             ! discard .
              lflag = 1
              istr  = nstr
          end if
        end if
        istr = istr+1
      end do
c
      if(lflag.eq.0) then                                   ! It's a number
        digit = stof(string,nstr)
      end if
c
      return
      end

      real*8 function stof(string,nstr)
c**************************************************************
c*
c*    This routine converts a real/integer number stored in a
c*    string(1:nstr) into a real*8 digit format
c*
c**************************************************************
      implicit none
	integer*4   nstr
	character*1 string(*)
c
      integer i,ipos,nsign,esign,nvalu
      integer               expo,valu(256)  
	logical next
      integer stof1                              ! function
c
      stof = 0d0 
c
c***  Sing decoding
c
      ipos = 1
      if(ichar(string(ipos)).eq.43) then         !  + sign
        nsign = 1
	  ipos  = ipos + 1
      else if(ichar(string(ipos)).eq.45) then    !  - sign
        nsign = -1
	  ipos  = ipos + 1
	else                                       !  no sing (+)
	  nsign = 1
	  ipos  = ipos 
	end if
c
c***  Base decoding
c
      nvalu = 0
      next  = .true.
      do while(next)
        if((ichar(string(ipos)).eq.68 ).or.        ! D
     .     (ichar(string(ipos)).eq.69 ).or.        ! E
     .     (ichar(string(ipos)).eq.100).or.        ! d
     .     (ichar(string(ipos)).eq.101).or.        ! e
     .     (ichar(string(ipos)).eq.46 )) then       ! .
           next = .false.
	  else
	     nvalu = nvalu + 1
	     valu(nvalu) = stof1(string(ipos))
	     ipos = ipos + 1
           if(ipos.eq.(nstr+1)) then
	        next = .false.
              ipos = ipos - 1
	     end if
	  end if
	end do
      do i = 1,nvalu
	   stof = stof + valu(i)*1d1**(nvalu-i)
      end do
c
c***  Decimal decoding
c
      if((ichar(string(ipos)).eq.46   ).and.
     .                 ipos  .ne.nstr) then
        ipos = ipos + 1
        nvalu = 0
        next  = .true.
        do while(next)
          if((ichar(string(ipos)).eq.68 ).or.        ! D
     .       (ichar(string(ipos)).eq.69 ).or.        ! E
     .       (ichar(string(ipos)).eq.100).or.        ! d
     .       (ichar(string(ipos)).eq.101)) then      ! e
             next = .false.
	    else
	       nvalu = nvalu + 1
	       valu(nvalu) = stof1(string(ipos))

	       ipos = ipos + 1
             if(ipos.eq.(nstr+1)) then
	          next = .false.
                ipos = ipos - 1
	       end if
	    end if
	  end do
	  do i = 1,nvalu
	     stof = stof + valu(i)*1d1**(-i)
        end do
	end if
c
c***  Exponent
c
      if(((ichar(string(ipos)).eq.68 ).or.        ! D
     .    (ichar(string(ipos)).eq.69 ).or.        ! E
     .    (ichar(string(ipos)).eq.100).or.        ! d
     .    (ichar(string(ipos)).eq.101)).and.      ! e
     .                  ipos  .ne.nstr) then
        ipos = ipos + 1
        if(ichar(string(ipos)).eq.43) then         !  + sign
           esign = 1
	     ipos  = ipos + 1
        else if(ichar(string(ipos)).eq.45) then    !  - sign
           esign = -1
	     ipos  = ipos + 1
	  else                                       !  no sing (+)
	     esign = 1
	     ipos  = ipos 
	  end if     
c        
        nvalu = 0
        next  = .true.
        do while(next)
           nvalu = nvalu + 1
           valu(nvalu) = stof1(string(ipos))

	     ipos = ipos + 1
           if(ipos.eq.(nstr+1)) then
	        next = .false.
              ipos = ipos - 1
	     end if
	  end do
	  expo = 0
	  do i = 1,nvalu
	     expo = expo + valu(i)*1d1**(nvalu-i)
        end do
        expo = esign*expo
c
        stof = stof*(1d1**expo)
	end if
c
      stof = nsign*stof
	end

      integer function stof1(string1)
c**************************************************************
c*
c*    Decodes a character*1 string
c*
c**************************************************************
      implicit none
	character*1 string1
c      
	if(string1.eq.'0') then
	  stof1 = 0
	else if(string1.eq.'1') then
	  stof1 = 1	 
	else if(string1.eq.'2') then
	  stof1 = 2	 
      else if(string1.eq.'3') then
	  stof1 = 3	 
	else if(string1.eq.'4') then
	  stof1 = 4	 
	else if(string1.eq.'5') then
	  stof1 = 5	 
	else if(string1.eq.'6') then
	  stof1 = 6	 
	else if(string1.eq.'7') then
	  stof1 = 7	 
	else if(string1.eq.'8') then
	  stof1 = 8	 
	else if(string1.eq.'9') then
	  stof1 = 9
	end if
	return
	end
