      program diagno
!***************************************************************************
!*
!*    Runs the diagno (DWM) program
!*
!***************************************************************************
      use io_parameters
	  use master_variables
      implicit none
!
      integer(kind=4)   :: iarg
      character(len=10) :: stime
	  character(len=8 ) :: sdate
!
	  character(len=100) :: message
      integer  (kind=4)  :: istat
!
!***  Gets input and log filenames from the call arguments
!
      iarg = 1                          
      call GETARG(iarg,finp)
      iarg = 2                          
      call GETARG(iarg,flog)
!
!***  Opens the log file
!
	  open (nlog,file=TRIM(flog),status='unknown')
!
      call DATE_AND_TIME(sdate,stime)
	  write(nlog,1) sdate(7:8),sdate(5:6),sdate(1:4),  &
	                stime(1:2),stime(3:4),stime(5:6)
   1  format(/,                         &
           '----------------',/, &
           ' DIAGNO PROGRAM ',/, &
           '----------------',/, &
           '                ',/, &
           '  Starting date ',a2,'-',a2,'-',a4,' at time ',a2,':',a2,':',a2)
!
!***  Reads FILES BLOCKS from input file
!
      call get_input_cha(finp,'FILES','TOPOGRAPHY_FILE_PATH',ftop,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
      call get_input_cha(finp,'FILES','ROUGHNESS_FILE_PATH',frou,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
      call get_input_cha(finp,'FILES','WIND_FILE_PATH',fmet,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
      call get_input_cha(finp,'FILES','DIAGNO_FILE_PATH',fdia,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
      call get_input_cha(finp,'FILES','OUTPUT_DIRECTORY',dump,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
!***  Reads TIME BLOCK form input file
!
     call get_input_int4(finp,'TIME','YEAR',ibyr,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_int4(finp,'TIME','MONTH',ibmo,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_int4(finp,'TIME','DAY',ibdy,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_int4(finp,'TIME','HOUR',ibhr,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_int4(finp,'TIME','MINUTE',ibmi,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea4(finp,'TIME','SIMULATION_INTERVAL_(SEC)',trun,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
!***  Reads GRID BLOCK from input file and allocates memory
!
      call readgrd
!
!***  Reads METEO BLOCK from input file
!
      call get_input_rea4(finp,'METEO','Z_REFERENCE_(M)',zref,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
      call get_input_rea4(finp,'METEO','X_STATION_(UTM_M)',x_stat,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
      call get_input_rea4(finp,'METEO','Y_STATION_(UTM_M)',y_stat,1,istat,message)
      if(istat.ne.0) call runend(-1,message)
!
!***  Gets zroughness 
!
      call readzrou
!
!***  Outputs input data
!
      call wridat
!
!***  Calls the engine run_diagno
!
      call run_diagno
!
!***  Ends the program
!
      call runend(1,'OK')
! 
      end 
