      SUBROUTINE DIVCEL(U,V,W,DIV,UB,VB,DIVMAX,K)
C
C     DIAGNO  VERSION 1.1  LEVEL 870717  WINDBC
C
      include 'diagno.inc'
C
      COMMON /D5/ NX,NY,NZ,DX,DY,DZ(NZMAX)
      DIMENSION U(NXMAX,NYMAX,1),V(NXMAX,NYMAX,1)
      DIMENSION W(NXMAX,NYMAX,1),DIV(NXMAX,NYMAX,1)
      DIMENSION UB(NYMAX,2,1),VB(NXMAX,2,1)
C
C     COMPUTES THE 3-D DIVERGENCE IN EACH GRID CELL
C
C     INPUTS:  U (R ARRAY)  - GRIDDED X-DIRECTION WIND COMPONENTS
C              V (R ARRAY)  - GRIDDED Y-DIRECTION WIND COMPONENTS
C              W (R ARRAY)  - GRIDDED VERTICAL WIND COMPONENTS
C              UB (R ARRAY) - U-COMPONENT BOUNDARY VALUES
C              VB (R ARRAY) - V-COMPONENT BOUNDARY VALUES
C
C     OUTPUTS:  DIV (R ARRAY) - GRIDDED 3-D DIVERGENCE
C
      HTOP=1.0
      DXI=1.0/(2.0*DX)
      DYI=1.0/(2.0*DY)
      DZI=1.0/DZ(K)
      DO 100 J=1,NY
      DO 100 I=1,NX
      DIV(I,J,K)=0.
      WPH=W(I,J,K+1)
      WMH=W(I,J,K)
      UPH=UB(J,2,K)
      IF(I.LT.NX) UPH=U(I+1,J,K)
      VPH=VB(I,2,K)
      IF(J.LT.NY) VPH=V(I,J+1,K)
      UMH=UB(J,1,K)
      IF(I.GT.1) UMH=U(I-1,J,K)
      VMH=VB(I,1,K)
      IF(J.GT.1) VMH=V(I,J-1,K)
C
C     DIVERGENCE IS EVALUATED USING CENTRAL DIFFERENCES
C
      DUDX=(UPH-UMH)*DXI
      DVDY=(VPH-VMH)*DYI
      DWDZ=(WPH-WMH)*DZI
      DIV(I,J,K)=HTOP*(DUDX+DVDY)+DWDZ
      DIVABS=ABS(DIV(I,J,K))
      DIVMAX=AMAX1(DIVABS,DIVMAX)
  100 CONTINUE
C
C     SCALE DIVERGENCE FOR TERRAIN-CONFORMAL SYSTEM
C
      DIVMAX=DIVMAX/HTOP
      RETURN
      END