      subroutine outres(time1,time2,UU,VV,NXMAX,NYMAX,NZMAX)
!***************************************************************************
!*
!*    Outputs results
!*
!***************************************************************************
	  use master_variables
	  use io_parameters
      implicit none
!
      integer(kind=4) :: NXMAX,NYMAX,NZMAX
	  real   (kind=4) :: time1,time2
	  real   (kind=4) :: UU(NXMAX,NYMAX,NZMAX),VV(NXMAX,NYMAX,NZMAX)
!
      integer(kind=4),save :: ipass=0
      character(len =250)  :: fname
	  integer  (kind=4  )  :: ipos
	  logical :: out_v
!
!***  Assigns
!
      u(1:nx,1:ny) = UU(1:nx,1:ny,1)
      v(1:nx,1:ny) = VV(1:nx,1:ny,1)
!
!***  First time
!
      if(ipass.eq.0) then
	     ipass = 1
         write(nlog,1) 
   1     format(/,                  &
              '----------------',/, &
              ' TIME EVOLUTION ',/, &
              '----------------')
!
         open(ndia,FILE=TRIM(fdia),STATUS='unknown',ERR=100,FORM='unformatted')
         write(ndia) nx,ny,dx,dy,x0,y0
!
	  end if
!
!***  Writes to the log file
!
      write(nlog,2) time1,time2
   2  format(' Results from time ',f10.2,' to time ',f10.2)
!
!***  Writes to the diagno binary file
!
      write(ndia) time1,time2,Tz0,Tzref,pres
      write(ndia) u(1:nx,1:ny)
      write(ndia) v(1:nx,1:ny)
!
!***  If necessary, writes to the GRD files
!
      out_v = .true.
      if(out_v) then
          fname = TRIM(dump)//'windu_'
		  ipos  = LEN_TRIM(fname)
		  write(fname(ipos+1:ipos+6),'(i6.6)') INT(time1)
	      fname = TRIM(fname)//'.grd'
          call wrigrd(fname,nx,ny,x0,y0,dx,dy,u)    
!      
	      fname = TRIM(dump)//'windv_'
		  ipos  = LEN_TRIM(fname)
		  write(fname(ipos+1:ipos+6),'(i6.6)') INT(time1)
	      fname = TRIM(fname)//'.grd'
          call wrigrd(fname,nx,ny,x0,y0,dx,dy,v)    
	  end if
!       
      return
!
!***  List of errors
!
 100  call runend(-1,'Error opening file'//TRIM(fdia))
 101  call runend(-1,'Error writing file'//TRIM(fdia))
      return
	  end subroutine outres

	  

