      subroutine readuni(time,TIME2,WT,US,VS,TZ00,TZ11)
!*************************************************************************************
!*
!*    This routine reads meteorological data from a meteo
!*    file at current time
!*
!*    OUTPUTS
!*      WT,US,VT
!*
!*    METEO FILE FORMATS
!*       CUP   format: time1(s) time2(s) u(m/s) v(m/s) Tz0(C) Tzref(C) pres(HPa)
!*       SONIC format: time1(s) time2(s) u(m/s) v(m/s) Tzref(C) ustar rmonin
!*
!*************************************************************************************
      use master_variables
	  use io_parameters
      implicit none
!
      real(kind=4)    :: WT,US,VS,time,TZ00,TZ11
      integer(kind=4),save :: ipass = 0
!
      integer  (kind=4 ) :: iyr,imo,idy,ihr,imi 
      real     (kind=4 ) :: time1,time2
      real     (kind=4 ) :: windu_uni,windv_uni,ustar_uni,wstar_uni,rmonin_uni
      character(len =10),save :: code
!
!***  Opens file
!
      if(ipass.eq.0) then
	     ipass = 1
         open(nmet,FILE=TRIM(fmet),STATUS='unknown',ERR=100)
         read(nmet,*,err=101) iyr,imo,idy,ihr,imi,code
! 
         if(iyr.ne.ibyr) call runend(-1,'Incongrous begin times in meteo and input files')
         if(imo.ne.ibmo) call runend(-1,'Incongrous begin times in meteo and input files')
         if(idy.ne.ibdy) call runend(-1,'Incongrous begin times in meteo and input files')
         if(ihr.ne.ibhr) call runend(-1,'Incongrous begin times in meteo and input files')
         if(imi.ne.ibmi) call runend(-1,'Incongrous begin times in meteo and input files')
      end if
!
!***  Reads
!
      if(TRIM(code).eq.'CUP'.or.TRIM(code).eq.'cup') then
!
!***  CUP anemometer
!
        read(nmet,*,err=101) time1,time2,windu_uni,windv_uni,Tz0,Tzref,pres
        Tz0    = Tz0   + 273.  ! C  --> K
		Tzref  = Tzref + 273.  ! C  --> K	 
!
      else if(TRIM(code).eq.'SONIC'.or.TRIM(code).eq.'sonic') then
!
!***  SONIC anemometer
!
        read(nmet,*,err=101) time1,time2,windu_uni,windv_uni,Tzref,ustar_uni,rmonin_uni
		Tzref  = Tzref + 273.  ! C  --> K	 
        Tz0    = Tzref
!
      else
	     call runend(-1,'Invalid anemometer code in meteo file')
      end if 
!
!***  Assigns readed values
!
      TIME2 = time2
      WT = 0.
	  US = windu_uni
	  VS = windv_uni
      TZ00 = Tz0
	  TZ11 = Tzref
!
      return
!
!***  List of errors
!
 100  call runend(-1,'Error opening file'//TRIM(fmet))
 101  call runend(-1,'Error reading file'//TRIM(fmet))
      return
	  end subroutine readuni


