      SUBROUTINE SMOOTH(U,V,UB,VB,NSMTH)
C
C     DIAGNO  VERSION 1.1  LEVEL 900221  SMOOTH    S. DOUGLAS, SAI
C
      include 'diagno.inc'
C
      DIMENSION U(NXMAX,NYMAX,1),V(NXMAX,NYMAX,1),
     1          UB(NYMAX,2,1),VB(NXMAX,2,1)
      COMMON /D5/ NX,NY,NZ,DX,DY,DZ(NZMAX)
C
C     APPLIES SMOOTHING TO INTERPOLATED FILEDS
C
C    INPUTS:  U (R ARRAY)  - GRIDDED X-DIRECTION WIND COMPONENTS
C             V (R ARRAY)  - GRIDDED Y-DIRECTION WIND COMPONENTS
C             UB (R ARRAY) - U-COMPONENT BOUNDARY VALUES
C             VB (R ARRAY) - V-COMPONENT BOUNDARY VALUES
C             NSMTH (I)    - NUMBER OF SMOOTHING PASSES FOR ALL
C                            LAYERS EXCEPT THE SURFACE LAYER
C
C     OUTPUTS:  U (R ARRAY)  - SMOOTHED X-DIRECTION WIND COMPONENTS
C               V (R ARRAY)  - SMOOTHED Y-DIRECTION WIND COMPONENTS
C
      DO 10 K=1,NZ
      DO 20 N=1,NSMTH
C
C     SMOOTH SURFACE LAYER ONLY TWICE
C
      IF (K .EQ. 1 .AND. N .GT. 2) GO TO 10
      DO 30 J=1,NY
      DO 30 I=1,NX
      IP1=I+1
      JP1=J+1
      IM1=I-1
      JM1=J-1
      UIM1=UB(J,1,K)
      IF (I .GT. 1) UIM1=U(IM1,J,K)
      UJM1=U(I,J,K)
      IF (J .GT. 1) UJM1=U(I,JM1,K)
      VIM1=V(I,J,K)
      IF (I .GT. 1) VIM1=V(IM1,J,K)
      VJM1=VB(I,1,K)
      IF (J .GT. 1) VJM1=V(I,JM1,K)
      UIP1=UB(J,2,K)
      IF (I .LT. NX) UIP1=U(IP1,J,K)
      UJP1=U(I,J,K)
      IF (J .LT. NY) UJP1=U(I,JP1,K)
      VIP1=V(I,J,K)
      IF (I .LT.NX) VIP1=V(IP1,J,K)
      VJP1=VB(I,2,K)
      IF (J .LT. NY) VJP1=V(I,JP1,K)
C
      U(I,J,K)=0.5*U(I,J,K)+0.125*(UIP1+UIM1+UJP1+UJM1)
      V(I,J,K)=0.5*V(I,J,K)+0.125*(VIP1+VIM1+VJP1+VJM1)
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      RETURN
      END