      SUBROUTINE TERSET(HTOPO,HMAX,TERRAD)
C
C     DIAGNO  VERSION 1.1  LEVEL 900221  TERSET    S.DOUGLAS, SAI
C
      include 'diagno.inc'
c
      COMMON /D5/ NX,NY,NZ,DX,DY,DZ(NZMAX)
      DIMENSION HTOPO(NXMAX,NYMAX),HMAX(NXMAX,NYMAX)
C
C     THIS SUBROUTINE DETERMINES THE HEIGHT (HMAX) OF THE HIGHEST
C     TERRAIN WITHIN A RADIUS = TERRAD (KM) OF THE POINT I,J
C
C
C     INPUT:  HTOPO (R ARRAY) - GRIDDED TERRAIN HEIGHTS
C             TERRAD (R)      - RADIUS OF SEARCH FOR HIGHEST TERRAIN
C                               HEIGHTS
C
C     OUTPUT:  HMAX (R ARRAY) - MAXIMUM TERRAIN HEIGHT WITHIN A
C                               GIVEN RADIUS
C
      DXK=DX*0.001
      DYK=DY*0.001
      IRANGE=NINT(TERRAD/DXK)
      JRANGE=NINT(TERRAD/DYK)
      IBNDY=NX-IRANGE
      JBNDY=NY-JRANGE
C
      DO 5 J=1,NY
      DO 5 I=1,NX
        HMAX(I,J)=HTOPO(I,J)
   5  CONTINUE
      DO 10 J=1,NY
      L1=1
      IF (J .GT. JRANGE) L1=J-JRANGE
      L2=NY
      IF (J .LT. JBNDY) L2=J+JRANGE
      DO 10 I=1,NX
      K1=1
      IF (I .GT. IRANGE) K1=I-IRANGE
      K2=NX
      IF (I .LT. IBNDY) K2=I+IRANGE
        DO 20 L=L1,L2
        DO 20 K=K1,K2
          XDIST=(K-I)*DXK
          YDIST=(L-J)*DYK
          DIST=SQRT(XDIST**2+YDIST**2)
          IF (DIST .GT. TERRAD) GO TO 20
          HMAX(I,J)=AMAX1(HMAX(I,J),HTOPO(K,L))
  20    CONTINUE
  10  CONTINUE
      RETURN
      END