      FUNCTION UNIDOT(A,B)
C
C     DIAGNO  VERSION 1.O  LEVEL 900221  UNIDOT
C
      DIMENSION A(3),B(3)
C
C     UNIDOT RETURNS THE DOT PRODUCT OF A UNIT VECTOR
C     PARALLEL TO "A" WITH A UNIT VECTOR PARALLEL TO "B"
C
C     INPUTS: A (R ARRAY) - VECTOR A
C             B (R ARRAY) - VECTOR B
C
C     OUTPUTS: UNIDOT (R) - DOT PRODUCT OF VECTORS A AND B
C
      DENOM = SQRT((A(1)**2+A(2)**2+A(3)**2)*(B(1)**2+B(2)**2+B(3)**2))
      UNIDOT = 0.
      IF(DENOM .EQ. 0.) RETURN
      DO 100 I=1,3
      UNIDOT = UNIDOT + A(I)*B(I)
  100 CONTINUE
      UNIDOT = UNIDOT/DENOM
      RETURN
      END