      SUBROUTINE WINDBC(U,V,UB,VB,K)
C
C     DIAGNO  VERSION 1.1  LEVEL 900221  WINDBC
C
      include 'diagno.inc'
C
      COMMON /D5/ NX,NY,NZ,DX,DY,DZ(NZMAX)
      DIMENSION U(NXMAX,NYMAX,1),V(NXMAX,NYMAX,1)
      DIMENSION UB(NYMAX,2,1),VB(NXMAX,2,1)
C
C     SETS BOUNDARY CONDITIONS FOR WIND FIELDS
C     NO INFLOW - NO OUTFLOW BOUNDARY CONDITIONS ARE USED
C
C     INPUTS:  U (R ARRAY) - GRIDDED X-DIRECTION WIND COMPONENTS
C              V (R ARRAY) - GRIDDED Y-DIRECTION WIND COMPONENTS
C              K (I)       - VERTICAL LEVEL INDEX
C
C     OUTPUTS:  UB (R ARRAY) - U-COMPONENT BOUNDARY VALUES
C               VB (R ARRAY) - V-COMPONENT BOUNDARY VALUES
C
C
C     SET BOUNDARY VELOCITIES
C
      DO 100 J=1,NY
      UB(J,1,K)=U(1,J,K)
      UB(J,2,K)=U(NX,J,K)
  100 CONTINUE
      DO 200 I=1,NX
      VB(I,1,K)=V(I,1,K)
      VB(I,2,K)=V(I,NY,K)
  200 CONTINUE
      RETURN
      END