      subroutine areal_source
!****************************************************************************
!*
!*    This routine simulates the behaviour of an areal source.
!*    Contaminant comes out of the ground at speed "up(i,j)" and has a 
!*    density of rho1
!*
!***************************************************************************
      use master_variables
      implicit none    
!
      integer(kind=4) :: i,j
      real   (kind=8) :: hp
!
      do j=1,ny
         do i=1,nx
            if(up(i,j) .GT. zero)then
               hp = hnew(i,j)+up(i,j)*dt
               rhonew(i,j)=(hnew(i,j)*rhonew(i,j)+dt*up(i,j)*rho1)/hp
               unew  (i,j)= hnew(i,j)*rhonew(i,j)*unew(i,j)/(hnew(i,j)*rhonew(i,j)+up(i,j)*dt*rho1)
               vnew  (i,j)= hnew(i,j)*rhonew(i,j)*vnew(i,j)/(hnew(i,j)*rhonew(i,j)+up(i,j)*dt*rho1)
               hnew  (i,j)= hp
            endif
         end do
      end do
!
      return
      end subroutine areal_source
