     subroutine boundary
!***************************************************************************
!*
!*   This routine imposes zero gradient boundary conditions
!*
!****************************************************************************
     use master_variables
     implicit none 
!
     integer(kind=4) :: i,j
!
      do j= ny1,ny2
!
!***     West side of the domain.
!
         if(u(nx1+1,j) .LT. 0.0)then  
            h  (nx1,j) = h  (nx1+1,j)
            u  (nx1,j) = u  (nx1+1,j)
            v  (nx1,j) = v  (nx1+1,j)
            rho(nx1,j) = rho(nx1+1,j)
         else
            h  (nx1,j) = 0.0
            u  (nx1,j) = 0.0
            v  (nx1,j) = v(nx1+1,j)
            rho(nx1,j) = rhoa
         endif
!
!***     East side of the domain.
!
         if(u(nx2-1,j) .GT. 0.0)then
            h  (nx2,j) = h  (nx2-1,j)
            u  (nx2,j) = u  (nx2-1,j)
            v  (nx2,j) = v  (nx2-1,j)
            rho(nx2,j) = rho(nx2-1,j)
         else
            h  (nx2,j) = 0.0
            u  (nx2,j) = 0.0
            v  (nx2,j) = v(nx2-1,j)
            rho(nx2,j) = rhoa
         endif
!
      end do
!
      do i = nx1,nx2
!
!***     North side of the domain.
!
         if(v(i,ny2-1) .GT. 0.0)then
            h  (i,ny2) = h  (i,ny2-1)
            u  (i,ny2) = u  (i,ny2-1)
            v  (i,ny2) = v  (i,ny2-1)
            rho(i,ny2) = rho(i,ny2-1)
         else
            h  (i,ny2) = 0.0
            u  (i,ny2) = u(i,ny2-1)
            v  (i,ny2) = 0.0
            rho(i,ny2) = rhoa
         endif
!
!***     South side of the domain.
!         
         if(v(i,ny1+1) .LT. 0.0)then
            h  (i,ny1) = h  (i,ny1+1)
            u  (i,ny1) = u  (i,ny1+1)
            v  (i,ny1) = v  (i,ny1+1)
            rho(i,ny1) = rho(i,ny1+1)
         else
            h  (i,ny1) = 0.0
            u  (i,ny1) = u(i,ny1+1)
            v  (i,ny1) = 0.0
            rho(i,ny1) = rhoa
         endif
!
      end do
      return
      end subroutine boundary

