      subroutine cliffsnew
!***************************************************************************
!*
!*     This routine searches for cliffs. The routine suppress motion into
!*     the cliff; thus there will be zero flow over the cliff until the
!*     height of the fluid exceeds that of the cliff!
!*
!***************************************************************************
      use master_variables
      implicit none
!
      integer(kind=4) :: i,j,ip1,im1,jp1,jm1

      do j=1,ny
         jp1 = min(j+1,ny)
         jm1 = max(j-1,1 )
         do i=1,nx
            ip1 = min(i+1,nx)
            im1 = max(i-1,1 )
!
!***        i-cliffs
!
            if(hnew(i,j)+g(i,j)-g(ip1,j) .LE. 0.0) then
               unew(i,j)=min(unew(i,j),0.0)
            endif
!
            if(hnew(i,j)+g(i,j)-g(im1,j) .LE. 0.0)then
               unew(i,j)=max(unew(i,j),0.0)
            endif
!
!***        j-cliffs
!
            if(hnew(i,j)+g(i,j)-g(i,jp1) .LE. 0.0)then
               vnew(i,j)=min(vnew(i,j),0.0)
            endif
!
            if(hnew(i,j)+g(i,j)-g(i,jm1) .LE. 0.0)then
               vnew(i,j)=max(vnew(i,j),0.0)
            endif
!
         end do
       end do
!
      return
      end subroutine cliffsnew


