      subroutine interiorpoint
!***************************************************************************
!*   
!*    This routine iterates the common-or-garden interior points
!*    using finite difference methods following Roache and Rottman.
!*
!***************************************************************************
      use master_variables
      implicit none
!
      integer(kind=4) :: i,j  
!
!***  Cliffs
!
      call cliffs
!
!***  The work variable w is the variable for each of the conservation 
!***  variables h, hu, hv. 
!
      w(1:nx,1:ny) = h(1:nx,1:ny)
      hflag = 1
      call zalesak
      hflag = 0
      do j=1,ny
      do i=1,nx
          hnew(i,j)=min(w(i,j),1000.0)
      end do
      end do
!
      w(1:nx,1:ny) = h(1:nx,1:ny)*u(1:nx,1:ny)*rho(1:nx,1:ny)
      call zalesak
      do j=1,ny
      do i=1,nx
            if(hnew(i,j) .gt. zrough(i,j))then
               unew(i,j) = w(i,j)/hnew(i,j)/rhonew(i,j)
            else
               unew(i,j) = 0.0
            endif
         end do
      end do
!
      w(1:nx,1:ny) = h(1:nx,1:ny)*v(1:nx,1:ny)*rho(1:nx,1:ny)
      call zalesak
      do j=1,ny
        do i=1,nx
        if(hnew(i,j) .gt. zrough(i,j))then
               vnew(i,j) = w(i,j)/hnew(i,j)/rhonew(i,j)
        else
               vnew(i,j) = 0.0
        endif
      end do
      end do
!
      w(1:nx,1:ny) = h(1:nx,1:ny)*(rho(1:nx,1:ny)-rhoa)
      rhoflag=1
      call zalesak
      rhoflag=0
      do j=1,ny
         do i=1,nx
            if(hnew(i,j) .GT. zrough(i,j))then
               rhonew(i,j) = max(min(rhoa+w(i,j)/hnew(i,j),rho1),rhoa)
            else
               rhonew(i,j)=rhoa
            endif
            if( ((hnew(i,j)*gi*(rhonew(i,j)-rhoa)   )/         &
              (unew(i,j)*unew(i,j)+ustar(i,j)*ustar(i,j)+0.01)).LT.0.001) rhonew(i,j) = rhoa
         end do
      end do
!
!***
!
      call cliffsnew
      call entrainment
      call nonadvectionbit
      call areal_source
      call cliffsnew
!
      return
      end subroutine interiorpoint
