      subroutine nonadvectionbit
!***************************************************************************
!*
!*    Adds the effect of non-uniform height to momflux;
!*    This is the hydrostatic difference in pressure on each side of the element.
!*
!***************************************************************************
      use master_variables
      implicit none
!
      integer(kind=4) :: i,j
      real   (kind=8) :: xmomu,xmomv,x,y,z,speed,xdragu,xdragv
!
      do j = ny1,ny2
         do i = nx1,nx2
!
            xmomu = 0.0
            xmomv = 0.0
!
            x = hnew(i,j)+g(i,j)-hnew(i+1,j)-g(i+1,j)
            y = min(hnew(i,j)+g(i,j),hnew(i+1,j)+g(i+1,j))-max(g(i,j),g(i+1,j))
            z = g(i,j)-g(i+1,j)
!
 270        if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "A"

               xmomu = xmomu- ( 0.5*rhoa         *x*x +     rhonew(i+1,j)*x*y  &
                               +0.5*rhonew(i+1,j)*y*y + 0.5*rhonew(i  ,j)*z*z  &
                              -z*(rhoa*x+rhonew(i+1,j)*y))
!              
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "B" 
               xmomu = xmomu- (     rhonew(i+1,j)*x*z - (rhonew(i+1,j)-rhoa)*x*y &
                               +0.5*rhonew(i+1,j)*y*y + 0.5*rhonew(i,j)*z*z      &
                               -    rhonew(i  ,j)*y*z)
!
            else if(x .LE. 0.0 .AND. y .LE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "C"

               xmomu = xmomu-0.5*rhonew(i,j)*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .LE. 0.0 .AND. z .GE. 0.0)then
!                                                                                  CASE "D"
               xmomu = xmomu-0.5*rhoa*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                  CASE "E"
               xmomu = xmomu-(0.5*rhoa*x*x+rhonew(i+1,j)*x*y+0.5*rhonew(i+1,j)*y*y)
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                  CASE "F"
               xmomu = xmomu +(rhonew(i+1,j)-rhoa)*x*y - 0.5*rhonew(i+1,j)*y*y
!
            else
!
!***        If the control gets to this point, it means that one of the
!***        forbidden combinations of signs has occurred. This is
!***        possibly due to the fact that y has to be of the correct sign, yet
!***        is the difference of two large numbers. 
!
              y=0.0
              goto 270
            end if
!
            x = hnew(i,j)+g(i,j)-hnew(i-1,j)-g(i-1,j)
            y = min(hnew(i,j)+g(i,j),hnew(i-1,j)+g(i-1,j))-max(g(i,j),g(i-1,j))
            z=g(i,j)-g(i-1,j)
!
  271       if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "A"
               xmomu = xmomu + ( 0.5*rhoa         *x*x +     rhonew(i-1,j)*x*y  &
                                +0.5*rhonew(i-1,j)*y*y + 0.5*rhonew(i  ,j)*z*z  &
                                -z*(rhoa*x+rhonew(i-1,j)*y))
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "B"
               xmomu=xmomu + (     rhonew(i-1,j)*x*z -(rhonew(i-1,j)-rhoa)*x*y &
                              +0.5*rhonew(i-1,j)*y*y + 0.5*rhonew(i  ,j)*z*z       &
                                  -rhonew(i,j)*y*z)
!
            else if(x .LE. 0.0 .AND. y .LE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "C"
               xmomu = xmomu+0.5*rhonew(i,j)*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .LE. 0.0 .AND. z .GE. 0.0)then
!                                                                                  CASE "D"
               xmomu = xmomu+0.5*rhoa*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                  CASE "E"
               xmomu = xmomu+ (0.5*rhoa*x*x + rhonew(i-1,j)*x*y+0.5*rhonew(i-1,j)*y*y)
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                  CASE "F"
               xmomu = xmomu-(rhonew(i-1,j)-rhoa)*x*y+0.5*rhonew(i-1,j)*y*y
!
            else
               y = 0.0
               goto 271
            end if
!
            x = hnew(i,j)+g(i,j)-hnew(i,j+1)-g(i,j+1)
            y = min(hnew(i,j)+g(i,j),hnew(i,j+1)+g(i,j+1))-max(g(i,j),g(i,j+1))
            z=g(i,j)-g(i,j+1)
!
   272      if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                  CASE "A"
               xmomv = xmomv- ( 0.5*rhoa         *x*x +     rhonew(i,j+1)*x*y  &
                               +0.5*rhonew(i,j+1)*y*y + 0.5*rhonew(i,j  )*z*z  &
                              -z*(rhoa*x+rhonew(i,j+1)*y))
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                   CASE "B"
               xmomv = xmomv- (     rhonew(i,j+1)*x*z -(rhonew(i,j+1)-rhoa)*x*y   &
                               +0.5*rhonew(i,j+1)*y*y +0.5*rhonew(i,j)*z*z        &
                               -rhonew(i,j)*y*z)
!
            else if(x .LE. 0.0 .AND. y .LE. 0.0 .AND. z .LE. 0.0)then
!                                                                                   CASE "C"
               xmomv = xmomv-0.5*rhonew(i,j)*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .LE. 0.0 .AND. z .GE. 0.0)then
!                                                                                   CASE "D"
               xmomv = xmomv-0.5*rhoa*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                   CASE "E"
               xmomv = xmomv- (0.5*rhoa*x*x+rhonew(i,j+1)*x*y+0.5*rhonew(i,j+1)*y*y)
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                   CASE "F"
               xmomv=xmomv +(rhonew(i,j+1)-rhoa)*x*y -0.5*rhonew(i,j+1)*y*y
!
            else 
               y=0.0
               goto 272
            end if
!
            x = hnew(i,j)+g(i,j)-hnew(i,j-1)-g(i,j-1)
            y = min(hnew(i,j)+g(i,j),hnew(i,j-1)+g(i,j-1))-max(g(i,j),g(i,j-1))
            z=g(i,j)-g(i,j-1)
!
  273       if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                   CASE "A"
               xmomv = xmomv+ ( 0.5*rhoa         *x*x +     rhonew(i,j-1)*x*y   &
                               +0.5*rhonew(i,j-1)*y*y + 0.5*rhonew(i,j  )*z*z   &
                              -z*(rhoa*x+rhonew(i,j-1)*y))
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .LE. 0.0)then
!                                                                                   CASE "B"
               xmomv=xmomv + (     rhonew(i,j-1)*x*z -(    rhonew(i,j-1)-rhoa)*x*y &
                              +0.5*rhonew(i,j-1)*y*y + 0.5*rhonew(i,j  )*z*z       &
                                  -rhonew(i,j)*y*z)
!
            else if(x .LE. 0.0 .AND. y .LE. 0.0 .AND. z .LE. 0.0)then
!                                                                                   CASE "C"
               xmomv=xmomv+0.5*rhonew(i,j)*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .LE. 0.0 .AND. z .GE. 0.0)then
!                                                                                   CASE "D"
               xmomv=xmomv+0.5*rhoa*hnew(i,j)*hnew(i,j)
!
            else if(x .GE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                   CASE "E"
               xmomv = xmomv+ (0.5*rhoa*x*x+rhonew(i,j-1)*x*y+0.5*rhonew(i,j-1)*y*y)
!
            else if(x .LE. 0.0 .AND. y .GE. 0.0 .AND. z .GE. 0.0)then
!                                                                                   CASE "F"
               xmomv = xmomv-(rhonew(i,j-1)-rhoa)*x*y+0.5*rhonew(i,j-1)*y*y
!
            else
              y=0.0
              goto 273
            end if
!
!***
!
            xmomu = xmomu*gi*shape
            xmomv = xmomv*gi*shape
!
            if(hnew(i,j) .GT. zrough(i,j))then
               unew(i,j) = unew(i,j)+ xmomu*dt/(hnew(i,j)*rhonew(i,j)*dx)
               vnew(i,j) = vnew(i,j)+ xmomv*dt/(hnew(i,j)*rhonew(i,j)*dy)
            else
               unew(i,j) = 0.0
               vnew(i,j) = 0.0
            endif
!
            xmomu = 0.0
            xmomv = 0.0
            speed = SQRT(unew(i,j)*unew(i,j)+vnew(i,j)*vnew(i,j))
!
            if(hnew(i,j) .GT. zrough(i,j))then
               xdragu = speed*unew(i,j)*cd(i,j)/hnew(i,j)
               xdragv = speed*vnew(i,j)*cd(i,j)/hnew(i,j)
            else
               xdragu   = 0.0
               xdragv   = 0.0
               unew(i,j)= 0.0
               vnew(i,j)= 0.0
            endif
!
            if(unew(i,j)*(unew(i,j)-xdragu) .GT. 0.0)then
               unew(i,j)=unew(i,j)-xdragu
            else
               unew(i,j)=0.0
            endif
!
            if(vnew(i,j)*(vnew(i,j)-xdragv) .GT. 0.0)then
               vnew(i,j)=vnew(i,j)-xdragv
            else
               vnew(i,j)=0.0
            endif
!
         end do
      end do
!
     return
     end subroutine nonadvectionbit

