      subroutine outres
!**********************************************************
!*
!*    This routine outputs the results at the current time
!*
!**********************************************************
      use io_parameters
      use master_variables
      implicit none
!
      character(len =250) :: fname
      integer  (kind=4  ) :: ipos,ihts,icri,ix,iy
      real     (kind=8  ) :: rho_z,rho_zrough,c_zrough,k
      real     (kind=8  ) :: get_rho_z
!
!***  writes the restart file
!
      call wrirst
!
!***  writes the results files
!
      if(out_h) then
        fname = TRIM(dump)//'h_'
        ipos  = LEN_TRIM(fname)
        write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
        fname = TRIM(fname)//'.grd'
        work8(1:nx,1:ny) = h(1:nx,1:ny)
        call wrigrid(fname,nx,ny,x0,y0,dx,dy,work8)    
      end if
!      
      if(out_u) then
        fname = TRIM(dump)//'u_'
        ipos  = LEN_TRIM(fname)
        write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
        fname = TRIM(fname)//'.grd'
        work8(1:nx,1:ny) = u(1:nx,1:ny)
        call wrigrid(fname,nx,ny,x0,y0,dx,dy,work8)    
      end if
!      
      if(out_v) then
        fname = TRIM(dump)//'v_'
        ipos  = LEN_TRIM(fname)
        write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
        fname = TRIM(fname)//'.grd'
        work8(1:nx,1:ny) = v(1:nx,1:ny)
        call wrigrid(fname,nx,ny,x0,y0,dx,dy,work8)    
      end if
!      
      if(out_rho) then
        fname = TRIM(dump)//'rho_'
        ipos  = LEN_TRIM(fname)
        write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
        fname = TRIM(fname)//'.grd'
        work8(1:nx,1:ny) = rho(1:nx,1:ny)
        call wrigrid(fname,nx,ny,x0,y0,dx,dy,work8)    
      end if
!      
      if(out_dose) then
        fname = TRIM(dump)//'dose_'
        ipos  = LEN_TRIM(fname)
        write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
        fname = TRIM(fname)//'.grd'
        call wrigrid(fname,nx,ny,x0,y0,dx,dy,dose)    
      end if
!
      if(out_c) then
         do ihts = 1,nhts
         fname = TRIM(dump)//'c_'
         ipos  = LEN_TRIM(fname)
         write(fname(ipos+1:ipos+4),'(i4.4)') INT(100*z_hts(ihts))
         fname = TRIM(fname)//'cm_'
         ipos  = LEN_TRIM(fname)
         write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
         fname = TRIM(fname)//'.grd'
!
!***        Calculates concentration
!
            do iy=1,ny
              do ix = 1,nx
                 rho_z = get_rho_z(rhoa,rho1,rho(ix,iy),shape,z_hts(ihts),h(ix,iy))            
                 work8(ix,iy) = c_bg + (1d6-c_bg)*(rho_z-rhoa)/(rho1-rhoa)   ! concentration in ppm
               end do
              end do   
              call wrigrid(fname,nx,ny,x0,y0,dx,dy,work8)
            end do
           end if
!
       if(out_z) then
         do icri = 1,ncri
            fname = TRIM(dump)//'z_'
            ipos  = LEN_TRIM(fname)
            write(fname(ipos+1:ipos+3),'(i3.3)') INT(c_cri(icri)/1d4)
                fname = TRIM(fname)//'%_'
                ipos  = LEN_TRIM(fname)
                write(fname(ipos+1:ipos+6),'(i6.6)') INT(time-mod(time,tevery))
                fname = TRIM(fname)//'.grd'
!
!***        Calculates z below which concentration is greater than the threshold
!***        value defined by the user. First look for concentration at zrough. If
!***        c(zrough)>c_crit then find the critical z.
!
            do iy=1,ny
               do ix = 1,nx
                  rho_zrough = get_rho_z(rhoa,rho1,rho(ix,iy),shape,zrough(ix,iy),h(ix,iy))            
                  c_zrough   = c_bg + (1d6-c_bg)*(rho_zrough-rhoa)/(rho1-rhoa)      ! concentration in ppm
!
                  if(c_zrough.gt.c_cri(icri)) then
                    k = ((c_cri(icri)-c_bg)*(rho1      -rhoa)*shape)/ &
                        ((1d6        -c_bg)*(rho(ix,iy)-rhoa)*2d0  )
                    k = max(1e-5,k)
                    work8(ix,iy) = -0.5d0*shape*h(ix,iy)*log(k)
                  else         
                    work8(ix,iy) = 0d0
                  end if
! 
               end do
             end do
             call wrigrid(fname,nx,ny,x0,y0,dx,dy,work8)
           end do
      end if
! 
      return
      end subroutine outres


