     subroutine readgrd
!****************************************************************
!*
!*    Reads GRID BLOCK from the input file and allocates memory
!*
!****************************************************************
     use io_parameters
     use master_variables
     implicit none
!
     character(len=100) :: message,word
     integer  (kind=4)  :: istat
!
!***  GRID BLOCK (except topography-related variables)
!
     call get_input_int4(finp,'GRID','NX',nx,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_int4(finp,'GRID','NY',ny,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'GRID','DX_(M)',dx,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'GRID','DY_(M)',dy,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'GRID','X_ORIGIN_(UTM_M)',x0,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'GRID','Y_ORIGIN_(UTM_M)',y0,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_cha (finp,'GRID','EXTRACT_TOPOGRAPHY_FROM_FILE',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        topofile = .true.
     else
     topofile = .false.
     end if
!
!*** Define the computational extension
!
     nx1 = 4
     nx2 = nx - 3
     ny1 = 4
     ny2 = ny - 3
!     
     return
     end subroutine readgrd

     
