     subroutine readout
!****************************************************************
!*
!*    Reads OUTPUT BLOCK from the input file 
!*
!****************************************************************
     use io_parameters
     use master_variables
    implicit none
!
     character(len=100) :: message,word
     integer  (kind=4)  :: istat
!
!*** OUTPUT BLOCK
!
     call get_input_rea8(finp,'OUTPUT','OUTPUT_INTERVAL_(SEC)',tevery,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_DOMAIN',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
         out_dom = .true.
     else
         out_dom = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_SOURCE',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_src = .true.
     else
        out_src = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_U_VELOCITY',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_u = .true.
     else
        out_u = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_V_VELOCITY',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
       out_v = .true.
     else
       out_v = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_H',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_h = .true.
     else
        out_h = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_RHO',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_rho = .true.
     else
        out_rho = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_DOSE',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_dose = .true.
     else
        out_dose = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_CONCENTRATION',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
       out_c = .true.
     else
       out_c = .false.
     end if
!
     if(out_c) then
        call get_input_rea8(finp,'OUTPUT','CONCENTRATION_BG',c_bg,1,istat,message)
        if(istat.ne.0) call runend(-1,message)
!
        call get_input_npar(finp,'OUTPUT','HEIGHTS_(M)',nhts,istat,message)
        if(istat.ne.0) call runend(-1,message)
!
        allocate(z_hts(nhts))
        call get_input_vec8(finp,'OUTPUT','HEIGHTS_(M)',z_hts,nhts,istat,message)
        if(istat.ne.0) call runend(-1,message)
!
     end if
!
     call get_input_cha (finp,'OUTPUT','OUTPUT_Z_CRITICAL',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_z = .true.
     else
        out_z = .false.
     end if
!
     if(out_z) then
!
        call get_input_npar(finp,'OUTPUT','CRITICAL_C_(%)',ncri,istat,message)
        if(istat.ne.0) call runend(-1,message)
!
        allocate(c_cri(ncri))
        call get_input_vec8(finp,'OUTPUT','CRITICAL_C_(%)',c_cri,ncri,istat,message)
        if(istat.ne.0) call runend(-1,message)
        c_cri(1:ncri) = min(1e2,c_cri(1:ncri))
        c_cri(1:ncri) = max(0e0,c_cri(1:ncri))
        c_cri(1:ncri) = 1d4*c_cri(1:ncri)          ! Convert from % to ppm
!
     end if
!
     call get_input_cha (finp,'OUTPUT','TRACK_POINTS',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
         out_pts = .true.
     else
         out_pts = .false.
     end if
!
     call get_input_cha (finp,'OUTPUT','TRACK_BOXES',word,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
     if(TRIM(word).eq.'YES'.or.TRIM(word).eq.'yes') then
        out_box = .true.
     else
       out_box = .false.
     end if
!	 
     return
     end subroutine readout
