    subroutine readpro
!****************************************************************
!*
!*    Reads PROPERTIES BLOCK from the input file 
!*
!****************************************************************
     use io_parameters
     use master_variables
     implicit none
!
     character(len=100) :: message
     integer  (kind=4)  :: istat
!
!***  OUTPUT BLOCK
!
     call get_input_rea8(finp,'PROPERTIES','AMBIENT_GAS_DENSITY_20C_(KG/M3)',rhoa_20,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'PROPERTIES','DENSE_GAS_DENSITY_20C_(KG/M3)',rho1_20,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'PROPERTIES','AVERAGED_TEMPERATURE_(C)',Tmean,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
     call get_input_rea8(finp,'PROPERTIES','DOSE_GAS_TOXIC_EXPONENT',xexp,1,istat,message)
     if(istat.ne.0) call runend(-1,message)
!
!*** Initializations
!
     Tmean  = Tmean + 273.
     rhoa   = rhoa_20*293./Tmean
     rho1   = rho1_20*293./Tmean
!
     return
     end subroutine readpro
