      subroutine setbox
!**********************************************************
!*
!*    This routine reads the track boxes
!*
!**********************************************************
      use io_parameters
      use master_variables
      implicit none
!
      logical         :: go_on 
      integer(kind=4) :: ibox,kbox
      real   (kind=8) :: xvoid,yvoid,zvoid,dxvoid,dyvoid
!
!***  Initializations
! 
      go_on = .true.
      nbox  = 0        ! boxes inside the domain
      kbox  = 0        ! total number of boxes
!
!***  Gets the number of boxes that are inside the computational domain
!
      open(90,FILE=TRIM(fbox),STATUS='unknown',ERR=100)
      do while(go_on)
        read(90,*,end=10,err=101) xvoid,yvoid
        if((x0.le.xvoid).and.((x0+(nx-1)*dx).ge.xvoid)) then
        if((y0.le.yvoid).and.((y0+(nx-1)*dy).ge.yvoid)) then
           nbox = nbox + 1
        end if
        end if
       kbox = kbox + 1
      end do
!
!***  Allocates memory
!
 10   continue
      allocate(i1_box(nbox))
      allocate(j1_box(nbox))
      allocate(i2_box(nbox))
      allocate(j2_box(nbox))
!
      allocate(x_box(nbox))
      allocate(y_box(nbox))
      allocate(z_box(nbox))
!
!***  Reads data
! 
      rewind(90)
      nbox = 0
      do ibox = 1,kbox 
           read(90,*,err=101) xvoid,yvoid,zvoid,dxvoid,dyvoid
           if((x0.le.xvoid).and.((x0+(nx-1)*dx).gt.xvoid)) then
           if((y0.le.yvoid).and.((y0+(nx-1)*dy).gt.yvoid)) then
            nbox = nbox + 1
            x_box (nbox) = xvoid
            y_box (nbox) = yvoid
            z_box (nbox) = zvoid
!
            i1_box(nbox) = max(INT((xvoid-x0-0.5*dxvoid)/dx)+2 ,1 ) 
            j1_box(nbox) = max(INT((yvoid-y0-0.5*dyvoid)/dy)+2 ,1 )
            i2_box(nbox) = min(INT((xvoid-x0+0.5*dxvoid)/dx)+1 ,nx) 
            j2_box(nbox) = min(INT((yvoid-y0+0.5*dyvoid)/dy)+1 ,ny)
!
         end if
         end if
      end do
      close(90)
!
      return
!
!*** List of errors
!
 100  call runend(-1,'Error opening file'//TRIM(fbox))
 101  call runend(-1,'Error reading file'//TRIM(fbox))
!      
     return
     end subroutine setbox
