      subroutine setpts
!**********************************************************
!*
!*    This routine reads the tracking points
!*
!**********************************************************
      use io_parameters
      use master_variables
      implicit none
!
      logical         :: go_on 
      integer(kind=4) :: ipts,kpts
      real   (kind=8) :: xvoid,yvoid,zvoid,s,t,st
!
!***  Initializations
! 
      go_on = .true.
      npts  = 0        ! points inside the domain
      kpts  = 0        ! total number of points
!
!***  Gets the number of points that are inside the computational domain
!
      open(90,FILE=TRIM(fpts),STATUS='unknown',ERR=100)
      do while(go_on)
         read(90,*,end=10,err=101) xvoid,yvoid,zvoid
         if((x0.le.xvoid).and.((x0+(nx-1)*dx).ge.xvoid)) then
         if((y0.le.yvoid).and.((y0+(nx-1)*dy).ge.yvoid)) then
            npts = npts + 1
         end if
         end if
            kpts = kpts + 1
      end do
!
!***  Allocates memory
!
 10   continue
      allocate(i_pts(npts))
      allocate(j_pts(npts))
!
      allocate(x_pts(npts))
      allocate(y_pts(npts))
      allocate(z_pts(npts))
      allocate(s_pts(4,npts))
!
!***  Reads data
! 
      rewind(90)
      npts = 0
      do ipts = 1,kpts 
          read(90,*,err=101) xvoid,yvoid,zvoid
          if((x0.le.xvoid).and.((x0+(nx-1)*dx).ge.xvoid)) then
          if((y0.le.yvoid).and.((y0+(nx-1)*dy).ge.yvoid)) then
            npts = npts + 1
            x_pts(npts) = xvoid
            y_pts(npts) = yvoid
            z_pts(npts) = zvoid
         end if
         end if
      end do
      close(90)
!
!***  Calculates the indexes of the points in the grid and shape functions   
!
      i_pts = INT((x_pts-x0)/dx)+1 
      j_pts = INT((y_pts-y0)/dy)+1 
! 
      do ipts = 1,npts
         s  = (x_pts(ipts)-(x0+(i_pts(ipts)-1)*dx))/dx        ! parameter s in (0,1)
         t  = (y_pts(ipts)-(y0+(j_pts(ipts)-1)*dy))/dy        ! parameter t in (0,1)
         s  = 2.0*s-1.0                                       ! parameter s in (-1,1)
         t  = 2.0*t-1.0                                       ! parameter t in (-1,1)
         st = s*t
         s_pts(1,ipts)=(1d0-t-s+st)*0.25                      ! 4         3
         s_pts(2,ipts)=(1d0-t+s-st)*0.25                      !
         s_pts(3,ipts)=(1d0+t+s+st)*0.25                      !      
         s_pts(4,ipts)=(1d0+t-s-st)*0.25                      ! 1         2
      end do
!
      return
!
!*** List of errors
!
 100  call runend(-1,'Error opening file'//TRIM(fpts))
 101  call runend(-1,'Error reading file'//TRIM(fpts))
!      
      return
     end subroutine setpts
