      subroutine timestep
!********************************************************************
!*
!*     This subroutine advances the simulation one time step.       
!*
!********************************************************************
      use master_variables
      implicit none     
!
!***  Initialize new values
!
      hnew(1:nx,1:ny) = h(1:nx,1:ny)
      unew(1:nx,1:ny) = u(1:nx,1:ny)
      vnew(1:nx,1:ny) = v(1:nx,1:ny)
!
!***  Solves
!
      call interiorpoint
!
!***  Update values
!
      h  (1:nx,1:ny) = max(0.0,hnew(1:nx,1:ny))
      u  (1:nx,1:ny) = unew  (1:nx,1:ny)
      v  (1:nx,1:ny) = vnew  (1:nx,1:ny)
      rho(1:nx,1:ny) = rhonew(1:nx,1:ny)
!
      call boundary
!
      return
      end subroutine timestep
