      subroutine tstepsize
!**************************************************************
!*
!*     This subroutine determines the time step size
!*
!**************************************************************
      use master_variables
      implicit none
! 
      integer(kind=4) :: i,j    
      real   (kind=8) :: umax,cmax,u1,c1
!
      umax= 0.1
      cmax= 0.0
!
      do j=1,ny
         do i=1,nx
!
            u1 = u(i,j)*u(i,j)+v(i,j)*v(i,j)
            if(u1.gt.umax) umax = u1
!
            c1= h(i,j)*(rho(i,j)-rhoa)/rho(i,j)
            if(c1.gt.cmax) cmax = c1
!
         end do
      end do
!
      dt = courant*min(dx,dy)/(SQRT(umax)+SQRT(gi*cmax))
!
      return
      end subroutine tstepsize
