      subroutine wribox
!**********************************************
!*
!*     Writes the tracking boxes file
!*
!**********************************************
      use io_parameters
      use master_variables
      implicit none
!
      integer(kind=4),save       :: ipass  = 0
      integer(kind=4),parameter  :: nboxmax = 100
      character(len =250)  :: fname
      integer(kind=4)      :: ibox,i,j
      real   (kind=8)      :: rho_z,c_z(nboxmax)
      real   (kind=8)      :: get_rho_z
!       
!***  File name
!
      fname = TRIM(dump)//'boxes_conc_ppm.csv'
!
!***  Opens the file
!
      if(ipass.eq.0) then
         ipass = 1
         open(90,FILE=TRIM(fname),STATUS='unknown',ERR=100) ! First time opens without appending
      else
         open(90,FILE=TRIM(fname),ACCESS='append' ,ERR=100) ! Opens appending
      end if
!
!***  Calculates c_z at all boxes
!
      do ibox = 1,min(nbox,nboxmax)
!
         c_z(ibox) = 0.0
         do j = j1_box(ibox),j2_box(ibox)   
             do i = i1_box(ibox),i2_box(ibox)
!
               rho_z = get_rho_z(rhoa,rho1,rho(i,j),shape,z_box(ibox),h(i,j))
!
               c_z(ibox) = c_z(ibox) + c_bg + &
               (1d6-c_bg)*(rho_z-rhoa)/(rho1-rhoa)   ! concentration in ppm
            end do
          end do
!
         c_z(ibox) = c_z(ibox)/((i2_box(ibox)-i1_box(ibox)+1)*(j2_box(ibox)-j1_box(ibox)+1)) 
!
       end do
!
!***    Writes the file
!
       write(90,10) time,(c_z(ibox),ibox=1,min(nbox,nboxmax))
  10   format(e13.6,100(';',1x,e13.6))
       close(90) 
!	 	     
       return
!
!***  List of errors
!
  100  call runend(-1,'Error opening file'//TRIM(fname))
!
      end subroutine wribox
