     subroutine wridat
!*****************************************************************
!*
!*   Writes input data to the log file
!*
!*****************************************************************
       use io_parameters
       use master_variables
       implicit none
!
       integer(kind=4)  :: iyr,imo,idy,ihr,imi,ise,ipts,ibox,icri
!
!*** Writes the file
!
       write(nlog,1) 
1      format(/,               &
            '------------',/, &
            ' INPUT DATA ',/, &
            '------------')
!
!*** TIME block
!
       call addtime(ibyr,ibmo,ibdy,ibhr,ibmi,iyr,imo,idy,ihr,imi,ise,trun)  

!
       write(nlog,10) ibdy,month(ibmo),ibyr,ibhr, ibmi*60,    &
            idy,month(imo ),iyr ,ihr ,(imi*60)+ise,&
            trun/36d2,trun
 10  format(/,                           &
           'TIME'                    ,/, &
           '  Initial time    : ',2x,i2.2,1x,a3,1x,i4.4,' at ',i2.2,' h ',i4.4,' s',/,&
           '  Final   time    : ',2x,i2.2,1x,a3,1x,i4.4,' at ',i2.2,' h ',i4.4,' s',/,&
           '  Time increment  : ',f6.1,' h (',f12.1,' s)')
       if(.not.restart) then
          write(nlog,11)
       else
          write(nlog,12) time/36d2,time
       end if
11     format(&
            '  Restart         : No')
12     format(&
            '  Restart from    : ',f6.1,' h (',f12.1,' s)')
!
!*** GRID block
!
       write(nlog,20) x0,y0,x0+(nx-1)*dx,y0+(ny-1)*dy,nx,ny,dx,dy,  &
            MINVAL(g),MAXVAL(g)
20     format(/,                                                 &
           'GRID',/,                                           &
           '  Bottom-left corner : (',f9.1,2x,f9.1,')',/,      &
           '  Top-right   corner : (',f9.1,2x,f9.1,')',/,      &
           '  Number points x    : ',i9  ,/,                   &
           '  Number points y    : ',i9  ,/,                   &
           '  X  grid spacing    : ',f9.1,/,                   &
           '  Y  grid spacing    : ',f9.1,/,                   &
           '  Min. topography    : ',f9.1,/,                   &
           '  Max. topography    : ',f9.1)
!
!*** PROPERTIES block
!
     write(nlog,40) rhoa_20,rho1_20,(Tmean-273.),rhoa,(Tmean-273.),rho1,(Tmean-273.),xexp
 40  format(/,                                                 &
           'PROPERTIES',/,                                     &
           '  Ambient gas density : ',f9.4,' at 20C'      ,/,      &
           '  Dense   gas density : ',f9.4,' at 20C'      ,/,      &
           '  Averaged temperature: ',f5.1,' C     '      ,/,      &
           '  Ambient gas density : ',f9.4,' at ',f5.1,'C',/,      &
           '  Dense   gas density : ',f9.4,' at ',f5.1,'C',/,      &
           '  Dose toxic exponent : ',f9.4)
!
!*** OUTPUT block
!
     write(nlog,50) tevery,TRIM(dump)
50   format(/,                                                 &
           'OUTPUT',/,                                         &
           '  Time interval (sec): ',f10.1,/,                  &
           '  Dump directory     : ',a)
!
     if(out_dom) then
        write(nlog,51 ) TRIM(dump)//'topog.grd'
     else
        write(nlog,510)
     end if
51   format(&
          '  Output domain      : yes',/, &
          '  Domain file name   : ',a)
510  format(&
          '  Output domain      : no')
!
     if(out_src) then
        write(nlog,511) TRIM(dump)//'source.grd'
     else
        write(nlog,512)
     end if
511  format(&
          '  Output source      : yes',/, &
          '  Source file name   : ',a)
512  format(&
          '  Output source      : no')
!	
     if(out_u) then
        write(nlog,52 ) 
     else
        write(nlog,520)
     end if
52   format(&
          '  Output u-velocity  : yes')
520  format(&
          '  Output u-velocity  : no ')
!
     if(out_v) then
        write(nlog,53 ) 
     else
        write(nlog,530)
     end if
53   format(&
          '  Output v-velocity  : yes')
530  format(&
          '  Output v-velocity  : no ')
!
     if(out_h) then
        write(nlog,54 ) 
     else
        write(nlog,540)
     end if
54   format(&
          '  Output height      : yes')
540  format(&
          '  Output height      : no ')
!
     if(out_rho) then
        write(nlog,55 ) 
     else
        write(nlog,550)
     end if
55   format(&
          '  Output density     : yes')
550  format(&
          '  Output density     : no ')
!
     if(out_dose) then
        write(nlog,56 ) 
     else
        write(nlog,560)
     end if
56   format(&
          '  Output dose        : yes')
560  format(&
          '  Output dose        : no ')
!
     if(out_c) then
        write(nlog,57 ) c_bg
        write(nlog,571) (z_hts(ipts),ipts=1,nhts)
     else
        write(nlog,570)
     end if
57   format(&
          '  Output concentr.   : yes',/,&
          '    Background ppm   : ',f7.2)
571  format(&
          '    Heights          : ',100(f7.2,1x))
570  format(&
          '  Output concentr.   : no ')
!
     if(out_z) then
        write(nlog,573) (c_cri(icri)/1d4,icri=1,ncri)
     else
        write(nlog,574)
     end if
573  format(&
          '  Output z critical  : yes',/,&
          '    Critical c in %  : ',100(f7.2,1x))
574  format(&
          '  Output z critical  : no ')
!
     if(out_pts) then
        write(nlog,58 ) 
        do ipts = 1,npts
           write(nlog,580) ipts,x_pts(ipts),y_pts(ipts),z_pts(ipts)
        end do
     else
        write(nlog,59)
     end if
58   format(&
          '  Track points       : yes')
580  format(&
          '                       Point ',i3,' coordinates ',f10.1,1x,f10.1,1x,f7.2)
59   format(&
          '  Track points       : no ')
!
     if(out_box) then
        write(nlog,60 ) 
        do ibox= 1,nbox
           write(nlog,61) ibox,x_box(ibox),y_box(ibox),z_box(ibox), &
                          i1_box(ibox),i2_box(ibox),j1_box(ibox),j2_box(ibox)   
        end do
     else
        write(nlog,65)
     end if
60   format(&
          '  Track boxes        : yes')
61   format(&
          '     Box ',i3,' Coordinates   ',2(f10.1,1x),f7.2,/, & 
          '             X-points from    ',i3,'  to  ',i3,/,& 
          '             Y-points from    ',i3,'  to  ',i3) 
65   format(&
          '  Track boxes        : no ')
!
     write(nlog,100)
100  format(/,               &
          '----------------',/, &
          ' TIME EVOLUTION ',/, &
          '----------------',/)
!
     return
     end subroutine wridat
