      subroutine wripts
!**********************************************
!*
!*     Writes the tracking points files
!*
!**********************************************
      use io_parameters
      use master_variables
      implicit none
!
      integer(kind=4),save       :: ipass  = 0
      integer(kind=4),parameter  :: nptmax = 100
      character(len =250)  :: fname
      integer(kind=4)      :: ipts,ix,iy
      real   (kind=8)      :: rho_p(4),rho_z,c_z(nptmax)
      real   (kind=8)      :: get_rho_z
!       
!***  File name
!
      fname = TRIM(dump)//'point_conc_ppm.csv'
!
!***  Opens the file
!
      if(ipass.eq.0) then
         ipass = 1
         open(90,FILE=TRIM(fname),STATUS='unknown',ERR=100) ! First time opens without appending
      else
         open(90,FILE=TRIM(fname),ACCESS='append' ,ERR=100) ! Opens appending
      end if
!
!***  Calculates c_z at all points
!
      do ipts = 1,min(npts,nptmax)
!
         ix = i_pts(ipts)
         iy = j_pts(ipts)
!
         rho_p(1) = get_rho_z(rhoa,rho1,rho(ix  ,iy  ),shape,z_pts(ipts),h(ix  ,iy))
         rho_p(2) = get_rho_z(rhoa,rho1,rho(ix+1,iy  ),shape,z_pts(ipts),h(ix+1,iy))
         rho_p(3) = get_rho_z(rhoa,rho1,rho(ix+1,iy+1),shape,z_pts(ipts),h(ix+1,iy+1))
         rho_p(4) = get_rho_z(rhoa,rho1,rho(ix  ,iy+1),shape,z_pts(ipts),h(ix  ,iy+1))
!
         rho_z = s_pts(1,ipts)*rho_p(1) +  &         ! interpolated density
                 s_pts(2,ipts)*rho_p(2) +  &
                 s_pts(3,ipts)*rho_p(3) +  &
                 s_pts(4,ipts)*rho_p(4) 
!
         c_z(ipts) = c_bg + (1d6-c_bg)*(rho_z-rhoa)/(rho1-rhoa)   ! concentration in ppm
!
       end do
!
!***    Writes the file
!
       write(90,10) time,(c_z(ipts),ipts=1,min(npts,nptmax))
  10   format(e13.6,100(';',1x,e13.6))
       close(90) 
!	 	     
       return
!
!***  List of errors
!
  100  call runend(-1,'Error opening file'//TRIM(fname))
!
      end subroutine wripts
