      subroutine wrirst
!**********************************************************
!*
!*    This routine writes the restart file
!*
!**********************************************************
        use io_parameters
        use master_variables
        implicit none
!
        integer(kind=4) :: ix,iy
        integer(kind=4) :: iyr,imo,idy,ihr,imi,ise
!
!***  Calculate current time 
!
        call addtime(ibyr,ibmo,ibdy,ibhr,ibmi,iyr,imo,idy,ihr,imi,ise,time)
!
!***  writes the restart file
!
        open(90,FILE=TRIM(frst),STATUS='unknown',ERR=100)
        write(90,1) iyr,imo,idy,ihr,imi,nx,ny,dx,dy,x0,y0
1       format('-----------------------------------'   ,/, &
             ' TWODEE restart file         '   ,/, &
             ' Current time   ',i4.4,i2.2,i2.2,i2.2,i2.2,/, &
             ' Grid dimensions',i4,1x,i4       ,/, &
             ' Grid sizes     ',f9.1,1x,f9.1   ,/, &
             ' Origin         ',f9.1,1x,f9.1   ,/, &
             '-----------------------------------')
!
        write(90,2) time,nx,ny,dx,dy,x0,y0
2       format(f9.1,1x,i6,1x,i6,4(f9.1,1x)) 
        do iy=1,ny
           write(90,10) (h(ix,iy),ix=1,nx)
        end do
        do iy=1,ny
           write(90,10) (u(ix,iy),ix=1,nx)
        end do
        do iy=1,ny
           write(90,10) (v(ix,iy),ix=1,nx)
        end do
        do iy=1,ny
           write(90,10) (rho(ix,iy),ix=1,nx)
        end do
        close(90)
!
10      format(1000(f7.3,1x))
        return
!
!***  List of errors
!
100     call runend(-1,'Error opening file'//TRIM(frst))
!      
        return
      end subroutine wrirst


