      subroutine wriwind
!***********************************************************
!*
!*    Writes the wind data summary to the log file
!*
!***********************************************************
      use master_variables
      use io_parameters
      implicit none
!
      character(len=250) :: fname
      integer(kind=4)    :: iyr,imo,idy,ihr,imi,ise
!
      if(TRIM(wind_model).eq.'UNIFORM'.or.TRIM(wind_model).eq.'uniform') then 
         fname = fmet
      else if(TRIM(wind_model).eq.'DIAGNO'.or.TRIM(wind_model).eq.'diagno') then    
         fname = fdia
      else
      fname = ' '
      end if
!
      call addtime(ibyr,ibmo,ibdy,ibhr,ibmi,iyr,imo,idy,ihr,imi,ise,time)  

      write(nlog,10) TRIM(fname),idy ,month(imo ),iyr ,ihr ,(imi*60)+ise
 10   format(/,  &
        'METEO FILE READ             '  ,/,   &  
        '  File name               : ',a,/,   & 
        '  From time               : ',2x,i2.2,1x,a3,1x,i4.4,' at ',i2.2,' h ',i4.4,' s')
!
      call addtime(ibyr,ibmo,ibdy,ibhr,ibmi,iyr,imo,idy,ihr,imi,ise,meteo_time)  
      write(nlog,11) idy ,month(imo ),iyr ,ihr ,(imi*60)+ise
 11   format(&
        '  To   time               : ',2x,i2.2,1x,a3,1x,i4.4,' at ',i2.2,' h ',i4.4,' s')
!
      write(nlog,12) INT(meteo_time-time)
 12   format( &
        '  Time increment (in sec) : ',i9)
!
      write(nlog,20) MAXVAL(windu(1:nx,1:ny)),      &
                     MINVAL(windu(1:nx,1:ny)),      &
                     SUM(windu(1:nx,1:ny))/(nx*ny)
 20   format( &
        '  X-VELOCITY   '     ,/,  &
        '     Minimum  :',f8.2,/,  &
        '     Maximum  :',f8.2,/,  &
        '     Average  :',f8.2)
!
      write(nlog,21) MAXVAL(windv(1:nx,1:ny)),      &
                    MINVAL(windv(1:nx,1:ny)),      &
                    SUM(windv(1:nx,1:ny))/(nx*ny)
 21   format( &
        '  Y-VELOCITY   '     ,/,  &
        '     Minimum  :',f8.2,/,  &
        '     Maximum  :',f8.2,/,  &
        '     Average  :',f8.2)
!
      write(nlog,22) MAXVAL(ustar(1:nx,1:ny)),      &
                     MINVAL(ustar(1:nx,1:ny)),      &
                     SUM(ustar(1:nx,1:ny))/(nx*ny)
 22   format( &
        '  USTAR        '     ,/,  &
        '     Minimum  :',f8.2,/,  &
        '     Maximum  :',f8.2,/,  &
        '     Average  :',f8.2)
!
      write(nlog,23) MAXVAL(rmonin(1:nx,1:ny)),      &
                     MINVAL(rmonin(1:nx,1:ny)),      &
                     SUM(rmonin(1:nx,1:ny))/(nx*ny)
 23   format( &
        '  MONIN-OBUKOV '     ,/,  &
        '     Minimum  :',f8.2,/,  &
        '     Maximum  :',f8.2,/,  &
        '     Average  :',f8.2)
!
      write(nlog,24) MAXVAL(cd(1:nx,1:ny)),      &
                    MINVAL(cd(1:nx,1:ny)),      &
                   SUM(cd(1:nx,1:ny))/(nx*ny)
 24   format( &
        '  DRAG COEFF.  '     ,/,  &
        '     Minimum  :',f8.5,/,  &
        '     Maximum  :',f8.5,/,  &
        '     Average  :',f8.5)
!
      return
      end subroutine wriwind
