      subroutine zalesak
!****************************************************************************
!*
!*
!****************************************************************************
      use master_variables
      implicit none
!
      integer(kind=4) :: i,j
      real   (kind=8) :: gridsize,a,one,two,three,dxinv,dyinv,dgridinv
!
!***  Fill the arrays flu, flv, fhu, fhv for lower and high order fluxes
!***  in the u and v directions
!
      call bothfluxschemes_w
!
!***  Compute wtd,pplus,pminus
!
      dxinv = 1.0/dx
      dyinv = 1.0/dy
      dgridinv = 0.5*(dxinv+dyinv)
! 
      do j = ny1,ny2
         do i= nx1,nx2
!
            wtd(i,j) = w(i,j) +(flu(i-1,j)-flu(i,j))*dxinv + (flv(i,j-1)-flv(i,j))*dyinv
!
            pplus(i,j)= max(fhu(i-1,j  )-flu(i-1,j  ),0.0)  &
                       -min(fhu(i  ,j  )-flu(i  ,j  ),0.0)  &
                       +max(fhv(i  ,j-1)-flv(i  ,j-1),0.0)  &
                       -min(fhv(i  ,j  )-flv(i  ,j  ),0.0)
!
            pminus(i,j)=-min(fhu(i-1,j  )-flu(i-1,j  ),0.0) &
                        +max(fhu(i  ,j  )-flu(i  ,j  ),0.0) &
                        -min(fhv(i  ,j-1)-flv(i  ,j-1),0.0) &
                        +max(fhv(i  ,j  )-flv(i  ,j  ),0.0)
!
         end do
      end do 
! 
!***  Test whether or not this routine has been called
!***  from the height part or not. If it has, then the wmax and wmin
!***  calculations will be different as the ground height g(i,j) must
!***  be taken into consideration. 
!
      if(hflag .EQ. 0)then
!
!***     Next lines take the max and min of non-cliff
!***     adjacent elements; they say ``if this one is not 
!***     a cliff, then take the max of wmax and that element.
!
         do j = ny1,ny2
            do i = nx1,nx2
!            
               wmax(i,j) = max(wtd(i,j),w(i,j))
               wmin(i,j) = min(wtd(i,j),w(i,j))
!
               if( (h(i+1,j)+g(i+1,j)) .GT. g(i  ,j) .AND.  &
                   (h(i  ,j)+g(i  ,j)) .GT. g(i+1,j) .AND.  &
                    h(i+1,j)           .GT. zero               )then
                  wmax(i,j) = max(w(i+1,j)*(1.0+(g(i+1,j)-g(i,j))/h(i+1,j)),wmax(i,j))
                  wmin(i,j) = min(w(i+1,j)*(1.0+(g(i+1,j)-g(i,j))/h(i+1,j)),wmin(i,j))
               endif
!
               if( (h(i-1,j)+g(i-1,j)) .GT. g(i  ,j) .AND.  &
                   (h(i  ,j)+g(i  ,j)) .GT. g(i-1,j) .AND.  &
                    h(i-1,j)           .GT. zero              )then
                  wmax(i,j) = max(w(i-1,j)*(1.0+(g(i-1,j)-g(i,j))/h(i-1,j)),wmax(i,j))
                  wmin(i,j) = min(w(i-1,j)*(1.0+(g(i-1,j)-g(i,j))/h(i-1,j)),wmin(i,j))
               endif
!
               if( (h(i,j+1)+g(i,j+1)) .GT. g(i,j  ) .AND.  &
                   (h(i,j  )+g(i,j  )) .GT. g(i,j+1) .AND.  &
                    h(i,j+1)           .GT. zero              )then
                  wmax(i,j) = max(w(i,j+1)*(1.0+(g(i,j+1)-g(i,j))/h(i,j+1)),wmax(i,j))
                  wmin(i,j) = min(w(i,j+1)*(1.0+(g(i,j+1)-g(i,j))/h(i,j+1)),wmin(i,j))
               endif
!
               if( (h(i,j-1)+g(i,j-1)) .GT. g(i,j  ) .AND.  &
                   (h(i,j  )+g(i,j  )) .GT. g(i,j-1) .AND.  &
                    h(i,j-1)           .GT. zero             )then
                  wmax(i,j) = max(w(i,j-1)*(1.0+(g(i,j-1)-g(i,j))/h(i,j-1)),wmax(i,j))
                  wmin(i,j) = min(w(i,j-1)*(1.0+(g(i,j-1)-g(i,j))/h(i,j-1)),wmin(i,j))
               endif
!
          end do
         end do
!
     else   ! hflag = 1
!
          do j = ny1,ny2
          do i = nx1,nx2
!
               wmax(i,j) = max(wtd(i,j),w(i,j)) + g(i,j)
               wmin(i,j) = min(wtd(i,j),w(i,j)) + g(i,j)
!
               if( (h(i+1,j)+g(i+1,j)-g(i  ,j)) .GT. 0.0 .AND. &
                   (h(i  ,j)+g(i  ,j)-g(i+1,j)) .GT. 0.0        )then
                  wmax(i,j)=max(w(i+1,j)+g(i+1,j),wmax(i,j))
                  wmin(i,j)=min(w(i+1,j)+g(i+1,j),wmin(i,j))
               endif
!
               if( (h(i-1,j)+g(i-1,j)-g(i  ,j)) .GT. 0.0 .AND. &
                   (h(i  ,j)+g(i  ,j)-g(i-1,j)) .GT. 0.0        )then
                  wmax(i,j)=max(w(i-1,j)+g(i-1,j),wmax(i,j))
                  wmin(i,j)=min(w(i-1,j)+g(i-1,j),wmin(i,j))
               endif
!
               if( (h(i,j+1)+g(i,j+1)-g(i,j  )) .GT. 0.0 .AND. &
                   (h(i,j  )+g(i,j  )-g(i,j+1)) .GT. 0.0        )then
                  wmax(i,j)=max(w(i,j+1)+g(i,j+1),wmax(i,j))
                  wmin(i,j)=min(w(i,j+1)+g(i,j+1),wmin(i,j))
               endif
!
               if( (h(i,j-1)+g(i,j-1)-g(i,j  )) .GT. 0.0 .AND. &
                   (h(i,j  )+g(i,j  )-g(i,j-1)) .GT. 0.0        )then
                  wmax(i,j)=max(w(i,j-1)+g(i,j-1),wmax(i,j))
                  wmin(i,j)=min(w(i,j-1)+g(i,j-1),wmin(i,j))
               endif
!
!***           Subtract the g's which we have been
!***           adding to the arguments of all those "min" and "max" functions
!
               wmax(i,j)=wmax(i,j)-g(i,j)
               wmin(i,j)=wmin(i,j)-g(i,j)
               wmin(i,j)=max(wmin(i,j),0.0)
           end do
         end do
      endif
!
!***  Calculates rplus and rminus
!
      gridsize = 0.5*(dx+dy)
      do j = ny1,ny2
          do i = nx1,nx2
!         
            if(pplus(i,j) .GT. zero) then
               rplus(i,j) = min(1.0,(wmax(i,j)-wtd(i,j))*gridsize/pplus(i,j))
            else
               rplus(i,j) = 0.0
            endif
!
            if(pminus(i,j) .GT. zero)then
               rminus(i,j) = min(1.0,(wtd(i,j)-wmin(i,j))*gridsize/pminus(i,j))
            else
               rminus(i,j)=0.0
            endif
!
        end do
     end do
!
!***  Calculates cu and cv
!
      do j = ny1,ny2
         do i = nx1,nx2
!
            if(fhu(i,j)-flu(i,j) .GE. 0.0)then
               cu(i,j) = min(rplus(i+1,j),rminus(i  ,j))
            else
               cu(i,j) = min(rplus(i  ,j),rminus(i+1,j))
            endif
!
            if(fhv(i,j)-flv(i,j) .GE. 0.0)then
               cv(i,j) = min(rplus(i,j+1),rminus(i,j  ))
            else
               cv(i,j) = min(rplus(i,j  ),rminus(i,j+1))
            endif
!
        end do
     end do
!
      do j = ny1,ny2
         do i = nx1,nx2
!
            a    = fhu(i,j)-flu(i,j)
            one  = a*(wtd(i+1,j)-wtd(i  ,j))
            two  = a*(wtd(i+2,j)-wtd(i+1,j))
            three= a*(wtd(i  ,j)-wtd(i-1,j))
            if( (one.LT.0.0).AND.((two.LT.0.0).OR.(three.LT.0.0)) ) cu(i,j)=0.0

            a    = fhv(i,j)-flv(i,j)
            one  = a*(wtd(i,j+1)-wtd(i,j  ))
            two  = a*(wtd(i,j+2)-wtd(i,j+1))
            three= a*(wtd(i,j  )-wtd(i,j-1))
            if( (one.LT.0.0).AND.((two.LT.0.0).OR.(three.LT.0.0)) ) cv(i,j)=0.0
!
        end do
     end do
!
!***  Finally, calculates w
!
      do j = ny1,ny2
         do i = nx1,nx2
!
            w(i,j) = wtd(i,j) + ( (fhu(i-1,j  )-flu(i-1,j  ))*cu(i-1,j  )         &
                                 -(fhu(i  ,j  )-flu(i  ,j  ))*cu(i  ,j  ))*dxinv  &
                              + ( (fhv(i  ,j-1)-flv(i  ,j-1))*cv(i  ,j-1)         &
                                 -(fhv(i  ,j  )-flv(i  ,j  ))*cv(i  ,j  ))*dyinv     
!     
        end do
      end do
!
      return
      end subroutine zalesak
